Loading...
Searching...
No Matches
juce::universal_midi_packets::Endpoint Class Reference

## Detailed Description

Represents a single MIDI endpoint, which may have up to one input and up to one output.

An Endpoint object just holds a snapshot of the physical endpoint's last known state at the point when the Endpoint instance was created. Instead of storing Endpoint instances, it's a better idea to store an EndpointId, and to call Endpoints::getEndpoint() to get an up-to-date snapshot.

To connect to an endpoint, use Session::connectInput() or Session::connectOutput() to create a connection in the context of a particular session.

The documentation for this class was generated from the following file:

- juce_audio_devices/midi_io/ump/juce_UMPEndpoint.h

## Public Member Functions

| Endpoint ()=default
Endpoint | withName (String x) const
Endpoint | withProtocol (std::optional< PacketProtocol > x) const
Endpoint | withDeviceInfo (DeviceInfo x) const
Endpoint | withProductInstanceId (String x) const
Endpoint | withUMPVersion (uint8_t major, uint8_t minor) const
Endpoint | withStaticBlocks (bool x=true) const
Endpoint | withMidi1Support (bool x=true) const
Endpoint | withMidi2Support (bool x=true) const
Endpoint | withReceiveJRSupport (bool x=true) const
Endpoint | withTransmitJRSupport (bool x=true) const
Endpoint | withReceiveJREnabled (bool x=true) const
Endpoint | withTransmitJREnabled (bool x=true) const
Endpoint | withBlocks (Span< const Block > x) const
| The block index is used to uniquely identify the block, so be sure to always declare blocks in a consistent order.
Endpoint | withNumBlocks (size_t x) const
| The number of blocks on this endpoint.
String | getName () const
| Returns the name of this endpoint.
DeviceInfo | getDeviceInfo () const
| Returns properties of the device that owns the endpoint.
String | getProductInstanceId () const
| Returns the product instance ID if available, or an empty string otherwise.
std::optional< PacketProtocol > | getProtocol () const
| The protocol that the endpoint currently expects to send and receive; endpoints are allowed to switch protocols, so this won't always return the same value.
uint8_t | getUMPVersionMajor () const
uint8_t | getUMPVersionMinor () const
bool | hasStaticBlocks () const
bool | hasMidi1Support () const
bool | hasMidi2Support () const
bool | hasReceiveJRSupport () const
bool | hasTransmitJRSupport () const
bool | isReceiveJREnabled () const
bool | isTransmitJREnabled () const
Span< const Block > | getBlocks () const &
| There can be a maximum of 32 blocks.
Span< Block > | getBlocks () &
| Returns a mutable view over the blocks in this endpoint.
Span< const Block > | getBlocks () const &&=delete
Span< Block > | getBlocks () &&=delete

## Constructors and Destructors

## Endpoint()

juce::universal_midi_packets::Endpoint::Endpoint | ( |  | ) |

default

Referenced by withBlocks(), withDeviceInfo(), withMidi1Support(), withMidi2Support(), withName(), withNumBlocks(), withProductInstanceId(), withProtocol(), withReceiveJREnabled(), withReceiveJRSupport(), withStaticBlocks(), withTransmitJREnabled(), withTransmitJRSupport(), and withUMPVersion().

## Member Functions

## withName()

Endpoint juce::universal_midi_packets::Endpoint::withName | ( | String | x | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withProtocol()

Endpoint juce::universal_midi_packets::Endpoint::withProtocol | ( | std::optional< PacketProtocol > | x | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withDeviceInfo()

Endpoint juce::universal_midi_packets::Endpoint::withDeviceInfo | ( | DeviceInfo | x | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withProductInstanceId()

Endpoint juce::universal_midi_packets::Endpoint::withProductInstanceId | ( | String | x | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withUMPVersion()

Endpoint juce::universal_midi_packets::Endpoint::withUMPVersion | ( | uint8_t | major,
|  | uint8_t | minor ) const

inline nodiscard

References Endpoint(), and juce::withMember().

## withStaticBlocks()

Endpoint juce::universal_midi_packets::Endpoint::withStaticBlocks | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withMidi1Support()

Endpoint juce::universal_midi_packets::Endpoint::withMidi1Support | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withMidi2Support()

Endpoint juce::universal_midi_packets::Endpoint::withMidi2Support | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withReceiveJRSupport()

Endpoint juce::universal_midi_packets::Endpoint::withReceiveJRSupport | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withTransmitJRSupport()

Endpoint juce::universal_midi_packets::Endpoint::withTransmitJRSupport | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withReceiveJREnabled()

Endpoint juce::universal_midi_packets::Endpoint::withReceiveJREnabled | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withTransmitJREnabled()

Endpoint juce::universal_midi_packets::Endpoint::withTransmitJREnabled | ( | bool | x = true | ) | const

inline nodiscard

References Endpoint(), juce::withMember(), and x.

## withBlocks()

Endpoint juce::universal_midi_packets::Endpoint::withBlocks | ( | Span< const Block > | x | ) | const

inline nodiscard

The block index is used to uniquely identify the block, so be sure to always declare blocks in a consistent order.

References Endpoint(), withNumBlocks(), and x.

## withNumBlocks()

Endpoint juce::universal_midi_packets::Endpoint::withNumBlocks | ( | size_t | x | ) | const

inline nodiscard

The number of blocks on this endpoint.

References Endpoint(), jassert, and x.

Referenced by withBlocks().

## getName()

String juce::universal_midi_packets::Endpoint::getName | ( |  | ) | const

inline

Returns the name of this endpoint.

## getDeviceInfo()

DeviceInfo juce::universal_midi_packets::Endpoint::getDeviceInfo | ( |  | ) | const

inline

Returns properties of the device that owns the endpoint.

## getProductInstanceId()

String juce::universal_midi_packets::Endpoint::getProductInstanceId | ( |  | ) | const

inline

Returns the product instance ID if available, or an empty string otherwise.

The product instance ID should match the device serial number, and should be unique per manufacturer, family, and model.

This ID can be used to distinguish between separate devices that have the same DeviceInfo. It can also be used to determine whether separate endpoints are associated with the same device.

## getProtocol()

std::optional< PacketProtocol > juce::universal_midi_packets::Endpoint::getProtocol | ( |  | ) | const

inline

The protocol that the endpoint currently expects to send and receive; endpoints are allowed to switch protocols, so this won't always return the same value.

May return nullopt if the protocol is unknown, perhaps because negotiation has not taken place.

## getUMPVersionMajor()

uint8_t juce::universal_midi_packets::Endpoint::getUMPVersionMajor | ( |  | ) | const

inline

## getUMPVersionMinor()

uint8_t juce::universal_midi_packets::Endpoint::getUMPVersionMinor | ( |  | ) | const

inline

## hasStaticBlocks()

bool juce::universal_midi_packets::Endpoint::hasStaticBlocks | ( |  | ) | const

inline

## hasMidi1Support()

bool juce::universal_midi_packets::Endpoint::hasMidi1Support | ( |  | ) | const

inline

## hasMidi2Support()

bool juce::universal_midi_packets::Endpoint::hasMidi2Support | ( |  | ) | const

inline

## hasReceiveJRSupport()

bool juce::universal_midi_packets::Endpoint::hasReceiveJRSupport | ( |  | ) | const

inline

## hasTransmitJRSupport()

bool juce::universal_midi_packets::Endpoint::hasTransmitJRSupport | ( |  | ) | const

inline

## isReceiveJREnabled()

bool juce::universal_midi_packets::Endpoint::isReceiveJREnabled | ( |  | ) | const

inline

## isTransmitJREnabled()

bool juce::universal_midi_packets::Endpoint::isTransmitJREnabled | ( |  | ) | const

inline

## getBlocks() [1/4]

Span< const Block > juce::universal_midi_packets::Endpoint::getBlocks | ( |  | ) | const &

inline

There can be a maximum of 32 blocks.

This may return an empty span if the endpoint has neither function blocks nor group terminal blocks.

Referenced by getBlocks().

## getBlocks() [2/4]

Span< Block > juce::universal_midi_packets::Endpoint::getBlocks | ( |  | ) | &

inline

Returns a mutable view over the blocks in this endpoint.

## getBlocks() [3/4]

Span< const Block > juce::universal_midi_packets::Endpoint::getBlocks | ( |  | ) | const &&

delete

## getBlocks() [4/4]

Span< Block > juce::universal_midi_packets::Endpoint::getBlocks | ( |  | ) | &&

delete

References getBlocks().

### Purchase

Get JUCE

### Discover

What's New in JUCE Features

### Learn

Documentaion Tutorials Made with JUCE Resources

### Support

JUCE Forum Newsletter Archive

### About

Contact Us JUCE Legal JUCE Licensing FAQ

### Events

Audio Developer Conference
© Raw Material Software Limited